Bug 429223 - Review Request: GASP - API wrapper for pygame for new programmers
Review Request: GASP - API wrapper for pygame for new programmers
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Dennis Gilmore
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-01-17 19:39 EST by ffm
Modified: 2008-03-03 21:16 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-03-03 21:16:52 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
dennis: fedora‑review+
bernie+fedora: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description ffm 2008-01-17 19:39:36 EST
Spec URL: http://teach.laptop.org/~ffm/rpms/SPECS/gasp.spec
SRPM URL: http://teach.laptop.org/~ffm/rpms/SRPMS/gasp-0.1-1.olpc2.src.rpm
Description: GASP provides a simple, procedural graphics API for beginning students using Python. GASP is built on top of pygame, and is designed to lead students into full use of the python and object oriented programming.

See also:
https://edge.launchpad.net/gasp
http://wiki.laptop.org/go/GASP
http://openbookproject.net//thinkCSpy/
Comment 1 ffm 2008-01-17 19:48:47 EST
By the way, this is my first package, and I am seeking a sponsor.
Comment 2 Bernie Innocenti 2008-01-18 03:48:53 EST
      - MUST: rpmlint must be run on every package. The output should be posted
in the review.

BAD: there are (minor) pylint warnings, please fix:

gasp.src: W: summary-ended-with-dot GASP provides a simple, procedural graphics
API for beginning students using Python. GASP is built on top of pygame, and is
designed to lead students into full use of the python and object oriented
programming.
gasp.src: E: summary-too-long GASP provides a simple, procedural graphics API
for beginning students using Python. GASP is built on top of pygame, and is
designed to lead students into full use of the python and object oriented
programming.

      - MUST: The package must be named according to the Package Naming Guidelines.
      - MUST: The spec file name must match the base package %{name}, in the
format %{name}.spec unless your package has an exemption on Package Naming
Guidelines.

BAD: something is weird here: the spec file contains "python-gasp", but the
package is called just "gasp".  I suggest using "python-gasp" for consistency
with the other python related packages.


      - MUST: The package must meet the Packaging Guidelines.

BAD: the description contains "Test 123".

      + MUST: The package must be licensed with a Fedora approved license and
meet the Licensing Guidelines.
      + MUST: The License field in the package spec file must match the actual
license.

Should the license tag be GPLv3 only or GPLv3+?  It's subtly different.

      + MUST: If (and only if) the source package includes the text of the
license(s) in its own file, then that file, containing the text of the
license(s) for the package must be included in %doc.
      + MUST: The spec file must be written in American English.
      + MUST: The spec file for the package MUST be legible. If the reviewer is
unable to read the spec file, it will be impossible to perform a review. Fedora
is not the place for entries into the Obfuscated Code Contest
(http://www.ioccc.org/).
      + MUST: The sources used to build the package must match the upstream
source, as provided in the spec URL. Reviewers should use md5sum for this task.
If no upstream URL can be specified for this package, please see the Source URL
Guidelines for how to deal with this.
      + MUST: The package must successfully compile and build into binary rpms
on at least one supported architecture.
      + MUST: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch needs to have a bug filed
in bugzilla, describing the reason that the package does not compile/build/work
on that architecture. The bug number should then be placed in a comment, next to
the corresponding ExcludeArch line. New packages will not have bugzilla entries
during the review process, so they should put this description in the comment
until the package is approved, then file the bugzilla entry, and replace the
long explanation with the bug number. (Extras Only) The bug should be marked as
blocking one (or more) of the following bugs to simplify tracking such issues:
FE-ExcludeArch-x86, FE-ExcludeArch-x64, FE-ExcludeArch-ppc, FE-ExcludeArch-ppc64
      + MUST: All build dependencies must be listed in BuildRequires, except for
any that are listed in the exceptions section of Packaging Guidelines; inclusion
of those as BuildRequires is optional. Apply common sense.
      + MUST: The spec file MUST handle locales properly. This is done by using
the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
      + MUST: Every binary RPM package which stores shared library files (not
just symlinks) in any of the dynamic linker's default paths, must call ldconfig
in %post and %postun. If the package has multiple subpackages with libraries,
each subpackage should also have a %post/%postun section that calls
/sbin/ldconfig. An example of the correct syntax for this is: 


      + MUST: If the package is designed to be relocatable, the packager must
state this fact in the request for review, along with the rationalization for
relocation of that specific package. Without this, use of Prefix: /usr is
considered a blocker.
      + MUST: A package must own all directories that it creates. If it does not
create a directory that it uses, then it should require a package which does
create that directory. Refer to the Guidelines for examples.
      + MUST: A package must not contain any duplicate files in the %files listing.
      + MUST: Permissions on files must be set properly. Executables should be
set with executable permissions, for example. Every %files section must include
a %defattr(...) line.
      + MUST: Each package must have a %clean section, which contains rm -rf
%{buildroot} (or $RPM_BUILD_ROOT).
      + MUST: Each package must consistently use macros, as described in the
macros section of Packaging Guidelines.
      + MUST: The package must contain code, or permissable content. This is
described in detail in the code vs. content section of Packaging Guidelines.
      + MUST: Large documentation files should go in a -doc subpackage. (The
definition of large is left up to the packager's best judgement, but is not
restricted to size. Large can refer to either size or quantity)
      + MUST: If a package includes something as %doc, it must not affect the
runtime of the application. To summarize: If it is in %doc, the program must run
properly if it is not present.
      + MUST: Header files must be in a -devel package.
      + MUST: Static libraries must be in a -static package.
      + MUST: Packages containing pkgconfig(.pc) files must 'Requires:
pkgconfig' (for directory ownership and usability).
      + MUST: If a package contains library files with a suffix (e.g.
libfoo.so.1.1), then library files that end in .so (without suffix) must go in a
-devel package.
      + MUST: In the vast majority of cases, devel packages must require the
base package using a fully versioned dependency: Requires: %{name} =
%{version}-%{release} 
      + MUST: Packages must NOT contain any .la libtool archives, these should
be removed in the spec.
      + MUST: Packages containing GUI applications must include a
%{name}.desktop file, and that file must be properly installed with
desktop-file-install in the %install section. This is described in detail in the
desktop files section of Packaging Guidelines. If you feel that your packaged
GUI application does not need a .desktop file, you must put a comment in the
spec file with your explanation.
      + MUST: Packages must not own files or directories already owned by other
packages. The rule of thumb here is that the first package to be installed
should own the files or directories that other packages may rely upon. This
means, for example, that no package in Fedora should ever share ownership with
any of the files or directories owned by the filesystem or man package. If you
feel that you have a good reason to own a file or directory that another package
owns, then please present that at package review time.
      + MUST: At the beginning of %install, each package MUST run rm -rf
%{buildroot} (or $RPM_BUILD_ROOT). See Prepping BuildRoot For %install for details.
      + MUST: All filenames in rpm packages must be valid UTF-8.

SHOULD Items:

    *

      + SHOULD: If the source package does not include license text(s) as a
separate file from upstream, the packager SHOULD query upstream to include it.
      - SHOULD: The description and summary sections in the package spec file
should contain translations for supported Non-English languages, if available.
      - SHOULD: The reviewer should test that the package builds in mock. See
MockTricks for details on how to do this.
      - SHOULD: The package should compile and build into binary rpms on all
supported architectures.
      - SHOULD: The reviewer should test that the package functions as
described. A package should not segfault instead of running, for example.
      - SHOULD: If scriptlets are used, those scriptlets must be sane. This is
vague, and left up to the reviewers judgement to determine sanity.
      - SHOULD: Usually, subpackages other than devel should require the base
package using a fully versioned dependency.
      - SHOULD: The placement of pkgconfig(.pc) files depends on their usecase,
and this is usually for development purposes, so should be placed in a -devel
pkg. A reasonable exception is that the main pkg itself is a devel tool not
installed in a user runtime, e.g. gcc or gdb.
      - SHOULD: If the package has file dependencies outside of /etc, /bin,
/sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the
file instead of the file itself. Please see File Dependencies in the Guidelines
for further information. 
Comment 3 ffm 2008-01-18 08:50:25 EST
All MUST items were fixed, 

However,
> - MUST: rpmlint must be run on every package. The output should be posted
in the review.
Running rpmlint produced no errors

> - SHOULD: The package should compile and build into binary rpms on all
supported architectures.
Files will be auto-compiled into bytecode on first use.

> - SHOULD: The reviewer should test that the package functions as
described. A package should not segfault instead of running, for example.
Tested and works.

> - SHOULD: Usually, subpackages other than devel should require the base
package using a fully versioned dependency.
Fixed.

Updated links:
http://teach.laptop.org/~ffm/rpms/SPECS/python-gasp.spec
http://teach.laptop.org/~ffm/rpms/SRPMS/python-gasp-0.1-1.olpc2.src.rpm

Anything I forgot?
Comment 4 Bernie Innocenti 2008-01-18 11:39:55 EST
> Anything I forgot?

Everything looks fine, except:

 - the version in the changelog entry does not match the package version
(0.1.0-1 vs 0.1-1)

I approve the package with this change.
Comment 5 ffm 2008-01-18 12:10:19 EST
Fixed. Changelog now reflects the package version, both are 0.1-1
Comment 6 Dennis Gilmore 2008-01-18 12:11:39 EST
There is no CVS request here.

quick glance the package does not meet the packaging guidelines 
in particular you dont need to Requires: python = 2.5 

http://fedoraproject.org/wiki/Packaging/Python

Im unsetting the approval
Comment 7 ffm 2008-01-18 12:32:06 EST
(In reply to comment #6)
> quick glance the package does not meet the packaging guidelines 
> in particular you dont need to Requires: python = 2.5 

Fixed.
Comment 8 Dennis Gilmore 2008-01-18 13:18:32 EST
Requires: python is also wrong.

Please read the packaging guidelines  rpm adds a requires "python(abi) = 2.5"  
you dont need to do something to pull python in. 


Please also increment the the release and put in changelog entries to show 
things being fixed during the review process.
Comment 9 ffm 2008-01-18 15:46:38 EST
(In reply to comment #8)
> Requires: python is also wrong.
> 
> Please read the packaging guidelines  rpm adds a requires "python(abi) = 2.5"  
> you dont need to do something to pull python in. 
Sorry, I did not notice that. 
 
> Please also increment the the release and put in changelog entries to show 
> things being fixed during the review process.
Done.

Thanks for bearing with me and my learning of this process, it is new to me.

Comment 11 Bernie Innocenti 2008-01-19 11:15:26 EST
Dennis, I just talked with FFM.  When the review process is done, please make me
the maintainer of this package.
Comment 12 Dennis Gilmore 2008-01-22 09:08:07 EST
[dennis@bratac ~]$ rpmlint /var/lib/mock//fedora-8-x86_64/result/*rpm
python-gasp.noarch: W: dangling-relative-symlink
/usr/share/doc/python-gasp-0.1/THANKS bzr-fetch/gasp-dev/THANKS
python-gasp.noarch: W: dangling-relative-symlink
/usr/share/doc/python-gasp-0.1/README bzr-fetch/gasp-dev/README
python-gasp.noarch: W: dangling-relative-symlink
/usr/share/doc/python-gasp-0.1/TODO bzr-fetch/gasp-dev/TODO
python-gasp.noarch: W: dangling-relative-symlink
/usr/share/doc/python-gasp-0.1/COPYRIGHT bzr-fetch/gasp-dev/COPYRIGHT
python-gasp.noarch: E: summary-too-long GASP provides a simple, procedural
graphics API for beginning students using Python
python-gasp.noarch: E: description-line-too-long GASP provides a simple,
procedural graphics API for beginning students using Python. It allows for the
easy creation of 1980's style games with litle or no prior programming experince.
python-gasp.noarch: E: description-line-too-long GASP is built on top of pygame,
and is designed to lead students into full use of the python and object oriented
programming.
python-gasp.src: E: summary-too-long GASP provides a simple, procedural graphics
API for beginning students using Python
python-gasp.src: E: description-line-too-long GASP provides a simple, procedural
graphics API for beginning students using Python. It allows for the easy
creation of 1980's style games with litle or no prior programming experince.
python-gasp.src: E: description-line-too-long GASP is built on top of pygame,
and is designed to lead students into full use of the python and objectoriented
programming.

They need fixing
Comment 15 Dennis Gilmore 2008-01-28 12:41:23 EST
[dennis@asgard dennis]$ wget 
http://teach.laptop.org/~ffm/rpms/SRPMS/python-gasp-0.1-4.olpc2.src.rpm
--11:41:09--  
http://teach.laptop.org/~ffm/rpms/SRPMS/python-gasp-0.1-4.olpc2.src.rpm
           => `python-gasp-0.1-4.olpc2.src.rpm'
Resolving teach.laptop.org... 18.85.46.54, 
2001:4830:2446:ff00:201:6cff:fe07:68d3
Connecting to teach.laptop.org|18.85.46.54|:80... connected.
HTTP request sent, awaiting response... 404 Not Found
11:41:09 ERROR 404: Not Found.
Comment 17 Dennis Gilmore 2008-01-30 22:20:29 EST
[dennis@bratac ~]$ sha1sum python-gasp-0.1.tar.bz2
fedora/SOURCES/python-gasp-0.1.tar.bz2
ed34be1d80392a0be1fa86e0b4693c2106b315f8  python-gasp-0.1.tar.bz2
ed34be1d80392a0be1fa86e0b4693c2106b315f8  fedora/SOURCES/python-gasp-0.1.tar.bz2

source matches upstream

provides and requires looks good

builds in mock on F-7 F-8 and devel 

rpmlint is quiet 
meets packaging guidelines
taking away FE-NEEDSPONSOR as bernie will be maintaining the package and he is
already sponsored.

approved
Comment 18 Bernie Innocenti 2008-01-30 22:58:47 EST
Thanks ffm.
Comment 19 Bernie Innocenti 2008-01-30 23:23:59 EST
New Package CVS Request
=======================
Package Name: python-gasp
Short Description: API wrapper for pygame for new programmers
Owners: bernie,m_stone
Branches: OLPC-2
InitialCC: 
Cvsextras Commits: yes
Comment 20 Dennis Gilmore 2008-01-30 23:43:55 EST
CVS Done
Comment 21 Bernie Innocenti 2008-03-03 21:16:52 EST
Imported and built for both devel and OLPC-2.

Note You need to log in before you can comment on or make changes to this bug.